/*
 * Created on Jul 7, 2005
 *This is a very simple example of one possible use of the 
 *Tacle code.  This example simple returns the number of 
 *reachable methods from a main method.
 */
package tacle.examples.simple;

import tacle.core.*;
import java.util.*;
import org.eclipse.jdt.core.IMethod;



public class HelloTacle {
	public int run(IMethod mainMethod){
		//this is the Tacle factory that will return an the specified 
		//implementation of ICallGraphAnalysis
		AnalysisFactory anaFac = new AnalysisFactory();
		//getting the RTA implementation of ICallGraphAnalysis
		ICallGraphAnalysis cga = anaFac.getAnalysis(AnalysisFactory.RTA);
		//Running the analysis on a main method
		cga.run(mainMethod);
		int ans = 0;
		//Get the set of reachable methods from main
		Set reachable = cga.getReachableIMethods();
		if(reachable != null){
			ans = reachable.size();
		}
		//return the size of the set
		return ans;
	}
	
}
