/*
 * Created on Jan 12, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package tacle.internal.rta;

import java.util.Set;

import org.eclipse.jdt.core.dom.ClassInstanceCreation;
import org.eclipse.jdt.core.dom.ConstructorInvocation;
import org.eclipse.jdt.core.dom.FieldDeclaration;
import org.eclipse.jdt.core.dom.IMethodBinding;
import org.eclipse.jdt.core.dom.ITypeBinding;
import org.eclipse.jdt.core.dom.Initializer;
import org.eclipse.jdt.core.dom.MethodDeclaration;
import org.eclipse.jdt.core.dom.MethodInvocation;
import org.eclipse.jdt.core.dom.Modifier;
import org.eclipse.jdt.core.dom.SimpleName;
import org.eclipse.jdt.core.dom.StringLiteral;
import org.eclipse.jdt.core.dom.SuperConstructorInvocation;
import org.eclipse.jdt.core.dom.SuperMethodInvocation;
import org.eclipse.jdt.core.dom.TypeDeclaration;

import tacle.internal.rta.data.ASTMethod;
import tacle.internal.rta.data.IWorklistType;
import tacle.internal.rta.data.IWorklistMethod;
import tacle.internal.rta.data.InfoDictionary;
/**
 * @author sharpm
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class LocationBasedMethodVisitor extends MethodVisitor {

	/**
	 * @author sharpm
	 * 
	 */
	private boolean isInMethod;
	
	// need to know which method to analyze
	LocationBasedMethodVisitor(RTAMethodWorklist worklist, 
			IWorklistMethod method) {
		super(worklist, method);
		isInMethod = false;
	}

	//// visiting methods

	public boolean visit(ClassInstanceCreation node) {
		if (isInMethod) {
			//System.out.println("Visiting... " + node);
			super.visit(node);
		}
		return true;
	}

	public boolean visit(ConstructorInvocation node) {
		if (isInMethod) {
			//System.out.println("Visiting... " + node);
			super.visit(node);
		}
		return true;
	}

	// visit only instance field declarations
	public boolean visit(FieldDeclaration node) {
		return false;
	}

	// assumed that the flags say if this is a static block
	public boolean visit(Initializer node) {
		return false;
	}

	public boolean visit(MethodDeclaration node) {
		if (node.getStartPosition()==((ASTMethod)method).getLocation()) {
			isInMethod = true;
			IMethodBinding mb = node.resolveBinding();
			((ASTMethod)method).setKey(mb.getKey());
			IWorklistType[] params = new IWorklistType[mb.getParameterTypes().length];
			for (int j = 0; j < params.length; j++) {
				params[j] = InfoDictionary.v().getTypeForBinding(
						mb.getParameterTypes()[j]);
			}
			((ASTMethod)method).setParameters(params);
			IWorklistType returnType = InfoDictionary.v()
					.getTypeForBinding(mb.getReturnType());
			((ASTMethod)method).setReturnType(returnType);
			IWorklistType declCls = InfoDictionary.v()
					.getTypeForBinding(mb.getDeclaringClass());
			((ASTMethod)method).setDeclaringClass(declCls);
			worklist.addMethodAfterAnalysis(method);
		} 
		return isInMethod;
	}

	public boolean visit(MethodInvocation node) {
		if (isInMethod) {
			//System.out.println(method + "Visiting... " + node);
			super.visit(node);
		}
		return true;
	}

	// this can be the name of a static field
	public boolean visit(SimpleName node) {
		if (isInMethod) {
			super.visit(node);
		}
		return true;
	}

	public boolean visit(StringLiteral node) {
		if (isInMethod) {
			super.visit(node);
		}
		return true;
	}

	public boolean visit(SuperConstructorInvocation node) {
		if (isInMethod) {
			//System.out.println("Visiting... " + node);
			super.visit(node);
		}
		return true;
	}

	public boolean visit(SuperMethodInvocation node) {
		if (isInMethod) {
			//System.out.println("Visiting... " + node);
			super.visit(node);
		}
		return true;
	}

	public boolean visit(TypeDeclaration node) {
		if (isInMethod) {
			//System.out.println("Visiting... " + node);
			super.visit(node);
		}
		return true;
	}

	// end visit
	// end of method
	public void endVisit(MethodDeclaration node) {
		if (node.getStartPosition()==((ASTMethod)method).getLocation()) {
			isInMethod = false;
		} 
	}

}
